<?php
/**
 * @file
 * Provide views data for campaign monitor subscriptions stored locally
 */

/**
 * Implements hook_views_data().
 */
function campaignmonitor_local_views_data() {
  // Applying to group auto joins the table for views
  $data['campaignmonitor_local_subscriptions']['table']['group'] = t('User');
  $data['campaignmonitor_local_subscriptions']['table']['provider'] = 'user';
  $data['campaignmonitor_local_subscriptions']['table']['entity_type'] = 'user';

  $data['campaignmonitor_local_subscriptions']['table']['join'] = array(
    'users_field_data' => array(
      'left_field' => 'uid',
      'field' => 'uid',
    ),
  );


  $data['campaignmonitor_local_subscriptions']['list_id'] = array(
    'title' => t('Lists'),
    'help' => t('Lists that a user belongs to.'),
    'field' => array(
      'id' => 'campaignmonitor_local_lists',
      'no group by' => TRUE,
    ),
    'filter' => array(
      'id' => 'standard',
    ),
    'argument' => array(
      'id' => 'standard',
    ),
    'sort' => array(
      'id' => 'standard',
    ),
  );

//  $data['campaignmonitor_local_subscriptions']['lists'] = array(
//    'title' => t('Lists'),
//    'help' => t('Lists that a user belongs to.'),
//    'field' => array(
//      'id' => 'field',
//    ),
//    'filter' => array(
//      'id' => 'string',
//    ),
//    'argument' => array(
//      'id' => 'string',
//    ),
//    'sort' => array(
//      'id' => 'standard',
//    ),
//    'entity field' => 'lists'
//  );

  $data['campaignmonitor_local_subscriptions']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('The time when the record was updated.'),
    'field' => array(
      'id' => 'date',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'id' => 'date',
    ),
    'argument' => array(
      'id' => 'date',
    ),
    'sort' => array(
      'id' => 'standard',
    ),
  );

  $data['campaignmonitor_local_lists']['table']['group'] = t('Campaign Monitor');

  $data['campaignmonitor_local_lists']['table']['join'] = array(
    'campaignmonitor_local_subscribers' => array(
      'left_field' => 'list_id',
      'field' => 'list_id',
    ),
  );

//  $data['campaignmonitor_local_lists']['name'] = array(
//    'title' => t('Name'),
//    'help' => t('Campaign Monitor List Names.'),
//    'field' => array(
//      'id' => 'campaignmonitor_local_lists',
//      'no group by' => TRUE
//    ),
//    'filter' => array(
//      'id' => 'standard',
//    ),
//    'argument' => array(
//      'id' => 'standard',
//    ),
////    'sort' => array(
////      'id' => 'campaignmonitor_local_lists',
////    ),
//  );

  $data['campaignmonitor_local_subscriptions']['table']['join'] = array(
    'campaignmonitor_local_lists' => array(
      'left_field' => 'list_id',
      'field' => 'list_id',
    ),
  );

//  $data['campaignmonitor_local_lists']['relationship'] = array(
//    'id' => 'campaignmonitor_local_handler_relationship',
//    'base' => 'campaignmonitor_local_subscriptions',
//    'base field' => 'list_id',
//    'label' => t('Subscription list name'),
//    'field name' => 'list_id',
//  );

//  $data['campaignmonitor_local_subscriptions']['list_id']['relationship'] = array(
//    'title' => t('Campaign Monitor list names'),
//    'id' => 'standard',
//    'base' => 'campaignmonitor_local_lists',
//    'base field' => 'list_id',
//    'label' => t('Subscription list name'),
//    'field name' => 'list_id',
//  );

  return $data;
}

/**
 * Implements hook_views_data_alter().
 */
function campaignmonitor_local_views_data_alter(&$data) {

  $data['users_field_data']['uid_subscriptions'] = array(
    'real field' => 'uid',
    'title' => t('Campaign Monitor subscriptions'),
    'help' => t('Display CM subscriptions.'),
    'field' => array(
      'id' => 'campaignmonitor_local_lists',
    )

  );

}

